std::swap(std::pair)(3)

NAME
std::swap(std::pair) - std::swap(std::pair)

Synopsis
   Defined in header <utility>
   template< class T1, class T2 >
                        (since C++11)
   void swap( std::pair<T1,T2>& x, std::pair<T1,T2>& y ) (until C++20)
       noexcept(/* see below */);
   template< class T1, class T2 >
   constexpr void swap( std::pair<T1,T2>& x, std::pair<T1,T2>& y (since C++20)
   ) (1)
       noexcept(/* see below */);
   template< class T1, class T2 >
   constexpr void swap( const std::pair<T1,T2>& x, const (2) (since C++23)
   std::pair<T1,T2>& y )
       noexcept(/* see below */);
   Swaps the contents of x and y. Equivalent to x.swap(y).
   1) This overload participates in overload resolution only if
   std::is_swappable_v<first_type> && std::is_swappable_v<second_type> is
   true. (since C++17)
   2) This overload participates in overload resolution only if
   std::is_swappable_v<const first_type> && std::is_swappable_v<const
   second_type> is true.

Parameters
   x, y - pairs whose contents to swap

Return value
   (none)

Exceptions
   noexcept specification:
   noexcept(noexcept(x.swap(y)))

Example
// Run this code
 #include <iostream>
 #include <utility>
 int main()
 {
     auto p1 = std::make_pair(10, 3.14);
     auto p2 = std::pair(12, 1.23); // CTAD, since C++17
     auto print_p1_p2 = [&](auto msg) {
         std::cout << msg
                   << "p1 = {" << std::get<0>(p1)
                   << ", " << std::get<1>(p1) << "}, "
                   << "p2 = {" << std::get<0>(p2)
                   << ", " << std::get<1>(p2) << "}\n";
     };
     print_p1_p2("Before p1.swap(p2): ");
     p1.swap(p2);
     print_p1_p2("After p1.swap(p2): ");
     std::swap(p1, p2);
     print_p1_p2("After swap(p1, p2): ");
 }

Output:
 Before p1.swap(p2): p1 = {10, 3.14}, p2 = {12, 1.23}
 After p1.swap(p2): p1 = {12, 1.23}, p2 = {10, 3.14}
 After swap(p1, p2): p1 = {10, 3.14}, p2 = {12, 1.23}

See also
   swap swaps the values of two objects
                        (function template)
   std::swap(std::tuple) specializes the std::swap algorithm
   (C++11) (function template)

Category:
     * conditionally noexcept